=== debian/changelog ===
jackd2 (1.9.7~dfsg-1ubuntu2) oneiric; urgency=low

  * Drop dh-buildinfo build-dependency; this creates conflicting
    per-architecture buildinfo.gz files that prevent multiarch
    co-installability, and all this information is already available in the
    build logs.
  * Build for multiarch.  LP: #861025.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Sep 2011 05:55:59 +0000

jackd2 (1.9.7~dfsg-1ubuntu1) oneiric; urgency=low

  * Merge from debian experimental, remaining changes:
    - Drop libcelt build dependency
    - debian/gbp.conf: Set debian-branch to ubuntu

 -- Luke Yelavich <themuso@ubuntu.com>  Mon, 08 Aug 2011 14:38:08 +1000

jackd2 (1.9.7~dfsg-1) unstable; urgency=low

  * New upstream version 1.9.7 (ALSA resume, new latency API)
  * Build with --mixed on i386 to be compatible with amd64.
  * Don't patch jack_connect for fast consecutive calls anymore, it's now
    using the same code as in jackd1 and waits for the port connection to
    appear.

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 31 Mar 2011 13:54:50 +0200
